/****************************************************************************
 *
 * Copyright (c) 2011
 *     Kevin Zhang
 *     All rights reserved.
 *
 * This file is the confidential and proprietary property of 
 * Kevin Zhang and the possession or use of this file requires 
 * a written license from the author.
 * Filename: 
 * Abstract:
 *          JZSearchAPI.h: definition of the JZSearch API
 * Author:   Kevin Zhang 
 *          (pipy_zhang@msn.com) www.nlpir.org
 * Date:     2011-8-20
 *
 * Notes:
 *                
 ****************************************************************************/
#if !defined(__JZSEARCH_2010_LIB_INCLUDED__)
#define __JZSEARCH_2010_LIB_INCLUDED__

#if	defined(_WIN32) || defined(WIN64)
#ifdef JZSEARCHAPI_EXPORTS
#define JZSearchAPI_API extern "C"  __declspec(dllexport)
#else
#define JZSearchAPI_API extern "C" __declspec(dllimport)
#endif
#else
#define JZSearchAPI_API extern "C" 
#endif
#include <stdio.h>
#include <vector>
//////////////////////////////////////////////////////////////////////////
//
//	²ΪֶζAPI
//
//////////////////////////////////////////////////////////////////////////

#define FIELD_TYPE_TEXT 1
#define FIELD_TYPE_INT 2
#define FIELD_TYPE_LONG 3
#define FIELD_TYPE_DATETIME 4
#define FIELD_TYPE_FLOAT 5
#define DATA_TYPE_BIGTEXT 6
#define FIELD_TYPE_NAME 8
JZSearchAPI_API int JZIndexer_FieldAdd(const char *sFieldName,const char *sDBFieldName,int nFieldType,bool bIndexed,bool bRetrieved);
//ֶ			ǷҪ	ǷҪ	ǷҪ洢	ǷΪͨ	
//sFieldName:ƣУΨһʾ
//sDBFieldNameӦݿֶƣݿʱڻȡݿ
//nFieldType:
	//FIELD_TYPE_TEXT
	//FIELD_TYPE_INT
	//FIELD_TYPE_LONG
	//FIELD_TYPE_DATETIME
//bIndexed:ǷҪ
//bRetrieved:ǷҪֶ


JZSearchAPI_API int JZIndexer_FieldSave(const char *sFieldInfoDataFile);
//Ϣļ
JZSearchAPI_API int JZIndexer_FieldLoad(const char *sFieldInfoDataFile);
//ȡѾõϢļ

JZSearchAPI_API int JZIndexer_FieldImport(const char *sTxtFile);
//Ϣļ
JZSearchAPI_API int JZIndexer_FieldExport(const char *sTxtFile,int bStatInfo=false);
//Ϣļ



//////////////////////////////////////////////////////////////////////////
//
//	²ΪAPI
//
//////////////////////////////////////////////////////////////////////////
#define INDEX_ENCODING_GBK 0
#define INDEX_ENCODING_UTF8 INDEX_ENCODING_GBK+1
#define INDEX_ENCODING_BIG5 INDEX_ENCODING_GBK+2
#define INDEX_ENCODING_GBK_FANTI INDEX_ENCODING_GBK+3//GBKа֣ͳһݣƼʹINDEX_ENCODING_GBK
#define INDEX_ENCODING_COUNT 4

#define LANGUAGE_TYPE_UNKNOWN 0
#define LANGUAGE_TYPE_CHINESE 1
#define LANGUAGE_TYPE_UYGHAN 2


JZSearchAPI_API int JZIndexer_Init(const char *sDictPath=0,const char *sFieldInfoFile=0,int encoding=INDEX_ENCODING_GBK,int bICTCLAS=false,int lang_type=LANGUAGE_TYPE_CHINESE,const char*sLicenceCode=NULL);
//ϵͳʼʼ󣬲ʹCJZIndexer
//sDictPathʵļΪʱn-gram
//sFieldInfoFile:ֶϢֶ֧Ϊֻ֧һֶ

#define JZINDEX_STATUS_NORMAL 0//״̬
#define JZINDEX_STATUS_PROCESSING 1//У
#define JZINDEX_STATUS_MERGE 2//ڹ鲢У
#define JZINDEX_STATUS_RELOAD 3//¼عУ
#define JZINDEX_STATUS_UPDATED 4//µݣûи¹
#define JZINDEX_STATUS_BACKUP 5//backup status,added in 2013/8/15
JZSearchAPI_API int JZIndexer_SetStatus(int nStatus);
//ϵͳ״̬ںĲٿ

JZSearchAPI_API int JZIndexer_Exit();
//ϵͳ˳



//
#ifdef OS_LINUX
class  CJZIndexer {
#else
class  __declspec(dllexport) CJZIndexer {
#endif
//class JZSearchAPI_API CJZIndexer {
public:
	//ڴС
	CJZIndexer(const char *pcIndexFile,int nMaxMemSize=512000000,int bIncrementalIndex=0 );

	~CJZIndexer(void);
	// TODO: add your methods here.
	int MemIndexing(const char *pText,const char *sFieldName=0,int nMemSize=0);
	//һڴ棬
	//sFieldNameֶƣΪʾֶϢ

	int FileIndexing(const char *sTextFilename,const char *sFieldName=0);
	//һıļ
	//sFieldNameֶƣΪʾֶϢ

	int BigFileIndexing(const char *sBigFilename,unsigned int nOffset,unsigned int nSize,const char *sFieldName=0);
	//һBig Fileָƫͳȵıļ
	//sBigFilename: Big Fileļ
	//nOffset:ƫ
	//nSize: ļ
	//sFieldNameֶƣΪʾֶϢ

	int IdIndexing(int term_id,const char *sFieldName=0,int nOffset=0xff,const char *sStoreData=NULL);
	//ID,
	//sFieldNameֶƣΪʾֶϢ
	//sStoreData: need to store

	int IntIndexing(int value,const char *sFieldName=0);
	//ֵ,
	//sFieldNameֶƣΪʾֶϢ
#ifndef _WIN32
	int LongIndexing(long long value,const char *sFieldName=0);
	//64λֵ,
	//sFieldNameֶƣΪʾֶϢ
#else
	int LongIndexing(__int64 value,const char *sFieldName=0);
	//64λֵ,
	//sFieldNameֶƣΪʾֶϢ
#endif
	int FloatIndexing(float value,const char *sFieldName=0);
	//ֵ,

	//sFieldNameֶƣΪʾֶϢ
	bool Save();
	//
	
	//
	int Merge();
	//ϲ
	
	int AddDoc();//ĵ
	int GetStatus();//ȡϵͳ״̬1ʾCIndexerɹ
private://²ΪϵͳʹãӦÿ߲Ҫдֻܶȡ
	int m_nHandle;//Handle
	int m_nStatus;
	char m_sBigfilename[1000];//big filename,added in 2011/12/4
	FILE *m_fpBigFile;//Big File pointer,added in 2011/12/4
};


//////////////////////////////////////////////////////////////////////////
//
//	²ΪAPI
//
//////////////////////////////////////////////////////////////////////////

#define SORT_TYPE_DOCID 1//Doc IDĬϷʽ
#define SORT_TYPE_RELEVANCE 2//ض
#define SORT_TYPE_DOCID_REVERSE 3//Doc IDĬϷʽ
#define  SEARCHER_HANDLE int

JZSearchAPI_API SEARCHER_HANDLE JZSearch_Init(const char *sIndexFile,const char *sDictPath=0,const char *sFieldInfoFile=0,size_t MaxMemSize=512000000,int encoding=INDEX_ENCODING_GBK,int nGroupMaxCount=0,int bICTCLAS=false,int lang_type=LANGUAGE_TYPE_CHINESE,const char*sLicenceCode=NULL);
//ϵͳʼʼ󣬲ʹCJZSearcher
//sDictPathʵļΪʱn-gram
//sIndexFileļ

JZSearchAPI_API int JZSearch_Exit(SEARCHER_HANDLE handle=0);
//handleϵͳ˳(handle==0)Ҫ˳ڴ濪

JZSearchAPI_API int JZSearch_Reload(SEARCHER_HANDLE handle=0);
//ϵͳº¼

JZSearchAPI_API unsigned int JZSearch_SetResultLimit(unsigned int nMaxResultLimit=1000);
//趨ؽ

JZSearchAPI_API const char * JZSearch_ReloadBlackList(void);
//ôʺº¼

JZSearchAPI_API const char * JZSearch_ReloadQueryExpand(void);
//չʸº¼

JZSearchAPI_API size_t JZSearch_AddSimDict(const char *sLine);
//ڴУͬ
//ʽ  w1 w1a w1b##w2 w2a w2b##w3 w3a w3b
//磺  ## 
/*********************************************************************
*
*  Func Name  : JZSearch_CleanQueryExpand
*
*  Description: Clean QueryExpand dictionary
*
*  Parameters : none
*
*  Returns    : prompt message
*
*  Author    :    NLPIR.org
*  History    :
*              1.create 9:9:2016
*********************************************************************/
JZSearchAPI_API bool JZSearch_CleanQueryExpand(void);

JZSearchAPI_API size_t JZSearch_AddSimDictFile(const char *sSimDictFile, const char *sAssociateDictFile);
//ͬʱļչʱͬʣ¼
//ʽ  w1 w1a w1b##w2 w2a w2b##w3 w3a w3b
//磺  ## 

JZSearchAPI_API int JZSearch_ListFieldAllValue(const char *sFieldLine,const char *sExportFile,bool bDuplicateErase=false,SEARCHER_HANDLE handle=1);
//гֶָ

JZSearchAPI_API int JZSearch_Export(const char *sExportFile,char arg,SEARCHER_HANDLE handle=1);
//ڲݣԱ˲

JZSearchAPI_API int JZSearch_ExportTF(const char *sExportFile,SEARCHER_HANDLE handle=1);
//ڲĴƵݣԱ˲飻added in 2015/7/5

JZSearchAPI_API int JZSearch_ExportTerm(int nTermID,const char *sExportFile,SEARCHER_HANDLE handle=0);
//ڲݣԱ˲

JZSearchAPI_API int JZSearch_Merge(SEARCHER_HANDLE handle=0);
//ϵͳԶŻ

JZSearchAPI_API int JZSearch_Backup(const char *sFilename=0,SEARCHER_HANDLE handle=0);
//ϵͳԶݣһ㲻ûʹãϵͳԶ

JZSearchAPI_API int JZSearch_Restore(SEARCHER_HANDLE handle=0);
//ϵͳԶظһ㲻ûʹãϵͳ޷صǰʱԶָ

typedef struct tRESULT_RECORD {//ṹڼʹ
	int doc_id;
	int offset;//ֶڵƫ
	double score;//õĴֻ
}RESULT_RECORD;
typedef RESULT_RECORD * RESULT_RECORD_VECTOR;
#ifdef OS_LINUX
class  CJZSearcher {
#else
class  __declspec(dllexport) CJZSearcher {
#endif
public:
	CJZSearcher(int sort_type=SORT_TYPE_RELEVANCE,SEARCHER_HANDLE handle=1);
	~CJZSearcher(void);
	// TODO: add your methods here.
	
	const char * Search(const char *query_line,int nStart,int nPageCount,const char *sResultName=0,bool bMemUsed=false,int *n_pResultCountRet=0);
	//query_line: ѯʽ
	//nStart:¼ʼַ
	//nPageCountǰҳؽĿ
	//nPageCount=-1:ǰҳҪеĽĿ
	//sResultName洢XMLַ
	//bMemUsed:false,ֵļУļsResultNameָsResultNameΪڴʼַ

	const RESULT_RECORD_VECTOR Search(const char *query_line,int *p_nResultCountRet,bool bNoSort=false,RESULT_RECORD_VECTOR pVecFKs=0,int nFKCount=0,const char *sFKFieldName=0);
	//query_line: ѯʽ
	//p_nResultCountRet:
	//bool bNoSort:
	
	int Search(const char *query_line,std::vector<int> &vecDocID);
	//query_line: ѯʽ
	//vecDocIDDocID
	//Return the result count
	//added in 2013/8/15

	//int GetDF(int nTermID, const char * sFiledName);
	//Get Document DF
	//const RESULT_RECORD_VECTOR GetInvertPostList(int nTermID, const char * sFiledName,int *p_nResultCountRet);

	//Get field value according to docID and fieldName
	const char * GetFiledValue(int nDocID, const char * sFiledName);
	////nDocID:Ҫȡļţ0ʼ
	////sFiledName:Ҫȡ	
	//added in 2013/8/15

	const char *GetResultBuf(const char *pcQuery, int nQuerySize, int &nBufSize,int nProtocol=2);//
	//Search(const char *query_line,int nStart,int nPageCount,const char *sResultName=0)ʹãȡ
	//ṩDBTSearchʹãDBTSearchͻ˱̽ӿڽ;Ӧÿ

	const RESULT_RECORD_VECTOR  GetForeignKeyValues(const char *sFieldName, int *nResultCountRet);
	//Search(const char *query_line,int nStart,int nPageCount,const char *sResultName=0)ʹãȡ
	//ָݵֵб

	bool DocDelete(int doc_id);

private://²ΪϵͳʹãӦÿ߲Ҫдֻܶȡ
	int m_nSearcherHandle;//Searcher handle;added in 2012/9/10
	int m_nHandle;
	int m_nSortType;//򷽷

	char *m_pResultBuf;
	int m_nResultMaxSize;//󳤶
};



//Added in 2015/3/6
#define JZSEARCH_HANDLE int 

JZSearchAPI_API JZSEARCH_HANDLE  JZIndexer_NewInstance(const char *pcIndexFile,int nMaxMemSize=512000000,int bIncrementalIndex=0);
//ʵʧܣ򷵻Ϊ-1ΪʵHandle
//bIncrementalIndex=1: 

JZSearchAPI_API int JZIndexer_MemIndexing(JZSEARCH_HANDLE handle,const char *pText,const char *sFieldName=0,int nMemSize=0);
//handleΪJZIndexer_NewInstanceصĽ
//һڴ棬
//sFieldNameֶƣΪʾֶϢ

JZSearchAPI_API int JZIndexer_FileIndexing(JZSEARCH_HANDLE handle,const char *sTextFilename,const char *sFieldName=0);
//һıļ
//sFieldNameֶƣΪʾֶϢ

JZSearchAPI_API int JZIndexer_BigFileIndexing(JZSEARCH_HANDLE handle,const char *sBigFilename,unsigned int nOffset,unsigned int nSize,const char *sFieldName=0);
	//һBig Fileָƫͳȵıļ
	//sBigFilename: Big Fileļ
	//nOffset:ƫ
	//nSize: ļ
	//sFieldNameֶƣΪʾֶϢ

JZSearchAPI_API int JZIndexer_IntIndexing(JZSEARCH_HANDLE handle,int value,const char *sFieldName=0);
//ֵ,
//sFieldNameֶƣΪʾֶϢ
#ifndef _WIN32
	int JZIndexer_LongIndexing(JZSEARCH_HANDLE handle,long long value,const char *sFieldName=0);
	//64λֵ,
	//sFieldNameֶƣΪʾֶϢ
#else
JZSearchAPI_API int JZIndexer_LongIndexing(JZSEARCH_HANDLE handle,__int64 value,const char *sFieldName=0);
	//64λֵ,
	//sFieldNameֶƣΪʾֶϢ
#endif
JZSearchAPI_API int JZIndexer_FloatIndexing(JZSEARCH_HANDLE handle,float value,const char *sFieldName=0);
	//ֵ,
	//sFieldNameֶƣΪʾֶϢ
JZSearchAPI_API int JZIndexer_Save(JZSEARCH_HANDLE handle);
	//
JZSearchAPI_API int JZIndexer_AddDoc(JZSEARCH_HANDLE handle);//ĵ
JZSearchAPI_API int JZIndexer_DeleteInstance(JZSEARCH_HANDLE handle);



JZSearchAPI_API JZSEARCH_HANDLE  JZSearcher_NewInstance(int sort_type=SORT_TYPE_RELEVANCE,SEARCHER_HANDLE handle=1);
//ʵʧܣ򷵻Ϊ-1ΪʵHandle

JZSearchAPI_API  const char* JZSearcher_Search(JZSEARCH_HANDLE handle,const char *query_line,int nStart,int nPageCount,const char *sResultXMLFile=0);
//query_line: ѯʽ
//nStart:¼ʼַ
//nPageCountǰҳؽĿ
//ǰҳҪеĽjasonַ
//const char *sResultXMLFile	ĬΪ0򣬴洢ļУadded in 2

JZSearchAPI_API int JZSearcher_DeleteInstance(JZSEARCH_HANDLE handle);
JZSearchAPI_API int JZSearch_SetAbstractArgu(unsigned int nAbstractLength,const char *sTagStart,const char*sTagEnd,int nPrefixLeng=6);
//Set Abstract Argument
//nAbstractLength:ժҪȣ
//sTagStartsTagEnd йؼʵĸʾǰHTML
//nPrefixLeng: ժҪǰ׺ĳ
JZSearchAPI_API int JZSearch_SetIndexSizeLimit(int nLimitSize=20480);
//ݵĳƣĬΪ20KBΪ-1ʾ

JZSearchAPI_API int JZSearch_SetUniqeCountLimit(int nLimitSize=100);//added in 2015/6/10
//UniqueȥһΪ100ർЧʵ
//nLimitSize<0ƣȫȥ

JZSearchAPI_API int JZSearch_SetHighlightFull(int nTrue=1);//added in 2016/10/22
//øʾǷֻʾַ롱ܺ ""
//True1 ֻʾַ
//False: ʾӴ

JZSearchAPI_API int JZSearch_DocDelete(JZSEARCH_HANDLE handle,int doc_id);//ɾhandleеڲΪdoc_idĵ
JZSearchAPI_API const char * JZSearch_GetLastErrorMsg();//ɾhandleеڲΪdoc_idĵ

#endif
